# Learning Reinforcement Learning on your own

## Outlook

The pages below contain teaching material from Olivier Sigaud's reinforcement learning (RL) lectures. They are designed to help you learn RL on your own. Each page contains at least slides, and most often lessons in youtube videos and notebooks corresponding to labs. There might also be additional material to go beyond the basics.

The order of the lessons below matters, if you want to understand a lot about RL and you don't have much prior knowledge, you are encouraged to work on these lessons sequentially. Getting a good grasp on RL from the "central flow of lessons" below may take something like 10 days of work to a motivated beginner.

The labs are based on [the bbrl library](https://github.com/osigaud/bbrl), before studying DQN you should have a look at [the bbrl documentation](https://github.com/osigaud/bbrl/tree/master/docs/overview.md) and [the bbrl introductory notebooks](https://github.com/osigaud/bbrl/tree/master/docs/notebooks).

These pages are subject to perpetual improvement, if you have any question or any suggestion to improve the content, send a message to Olivier.Sigaud@sorbonne-universite.fr.

## Reinforcement Learning: Central flow of lessons

[Overview: the 5 routes to Deep RL](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/overview.md)

------------

[Tabular dynamic programming](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/tabular_dp.md)

[Tabular model-free reinforcement learning](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/tabular_mfrl.md)

[Tabular model-based reinforcement learning](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/tabular_mbrl.md)

------------

[Deep Q-Network (DQN) and its successors](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/dqn.md)

[Deep Deterministic Policy Gradient (DDPG) and Twin Delayed Deep Deterministic Policy Gradient (TD3)](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/ddpg.md)

[On-policy vs Off-policy](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/onp_ofp.md)

[Policy Gradient approaches](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/reinforce.md)

[Bias vs Variance](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/bias_variance.md)

[Advantage Actor-Critic (A2C)](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/a2c.md)

[Trust Region Policy Optimization (TRPO) and ACKTR](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/trpo.md)

[Proximal Policy Optimization (PPO)](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/ppo.md)

[Soft Actor-Critic (SAC)](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/sac.md)

[High UTD ratio algorithms (TQC, DroQ)](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/high_UTD.md)

[Deel Model-free RL Wrap-Up](https://github.com/osigaud/bbrl/tree/master/docs/learning_RL/wrap_up.md)

------------

<!---
## Beyond standard RL approaches

Imitation learning

Direct Policy Search (DPS) approaches

Combining DPS and RL
--->
